// 005 u_irp_05_multi_page
// 28 jan 2008

// -- (C) Felix John COLIBRI 2008
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_irp_05_multi_page;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, Controls,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWGrids,
  IWDBGrids, DB, DBClient, IWCompButton, RpRender, RpRenderPDF, RpBase,
  RpSystem, RpCon, RpConDS, RpDefine, RpRave, IWCompLabel, IWCompListbox;

type
  TIWForm1 = class(TIWAppForm)
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    IWDBGrid1: TIWDBGrid;
    RvProject1: TRvProject;
    RvSystem1: TRvSystem;
    RvRenderPDF1: TRvRenderPDF;
    GenerateAndDisplay: TIWButton;
    IWLabel1: TIWLabel;
    IWLabel2: TIWLabel;
    IWListbox1: TIWListbox;
    procedure IWListbox1Click(Sender: TObject);
    procedure GenerateAndDisplayClick(Sender: TObject);
  public
  end;

implementation
  uses SyncObjs
      , u_irp_05_multi_ServerController
      , RVData, RVDriverDataView, RvDlBDE
      ;

  {$R *.dfm}

    var g_sort_column: String= '';

    procedure TIWForm1.GenerateAndDisplayClick(Sender: TObject);
      var l_pdf_file_name: string;
          l_session_id_segment: String;

      procedure generate_pdf;
        begin
          With RvProject1 do
          begin
            ProjectFile:= WebApplication.ApplicationPath+ '..\_data\r_driver_employee.rav';

            Open;

            with ProjMan.FindRaveComponent('DriverDataView1', nil) As TRaveDriverDataView do
              Query:=
                  'SELECT * '
                + '  FROM employee'
                + ' ORDER BY '+ g_sort_column
                ;
          end; // with RvProject1      

          with RvSystem1 do
          begin
            DoNativeOutput:= False;
            RenderObject:= RvRenderPDF1;
            OutputFileName:= IWServerController.FilesDir
                + l_session_id_segment+ '\'+ l_pdf_file_name;
          end; // with RvSystem1

          // -- create the user specific path
          ForceDirectories(ExtractFileDir(RvSystem1.OutputFileName));

          iwLabel1.Caption:= 'not ok';
          try
            RvProject1.ExecuteReport('Report1');

            iwLabel1.Caption:= 'ok';
          finally
            RvSystem1.OutputFileName:= '';

            iwLabel1.Caption:= iwLabel1.Caption+ ' unlocked';
          end; // try/finally
        end; // generate_pdf

      procedure display_pdf;
        var l_pdf_url: String;

            l_popup_page_name: string;
            l_popup_page_options: string;
            l_popup_parameter: String;
        begin
          l_pdf_url:= WebApplication.AppURLBase+ '/files/'+ l_session_id_segment+ '/'+ l_pdf_file_name;
          IwLabel2.Caption:= l_pdf_url;

          l_popup_page_name:= 'the_report';
          l_popup_page_options:= 'scrollbars=yes,width=500,height=300';
          l_popup_parameter:= 'NewWindow("'
              + l_pdf_url
              + '", "'+ l_popup_page_name
              + '","'+ l_popup_page_options
              + '");';

          AddToInitProc(l_popup_parameter);
        end; // display_pdf

      begin // GenerateAndDisplayClick
        l_session_id_segment:= WebApplication.AppID;
        l_pdf_file_name:= 'multi_report_'+ g_sort_column+ '_'+ l_session_id_segment+ '.pdf';

        generate_pdf;
        display_pdf;
      end; // GenerateAndDisplayClick

    procedure TIWForm1.IWListbox1Click(Sender: TObject);
      begin
        with IwListBox1 do
          case ItemIndex of
            0 : g_sort_column:= 'EmpNo';
            1 : g_sort_column:= 'LastName';
            2 : g_sort_column:= 'PhoneExt';
            else g_sort_column:= '';
          end; // case

        ClientDataSet1.IndexFieldNames:= g_sort_column;
      end; // IWListbox1Click

    initialization
      TIWForm1.SetAsMainForm;
    finalization
    end.
